Compiler.Control.Print.printLength := 1000;
Compiler.Control.Print.printLength := 1000;
Compiler.Control.Print.stringDepth := 200;

use "defs.sml";
use "parse.sml";
use "misc.sml";
use "pp.sml";
use "pt.sml";
use "redct.sml";
use "simplex.sml";
use "redcu.sml";
use "sat.sml";
use "solve.sml";
use "sampl.sml";

(*
   usage: 'solve<i> <process>':bool 
      i=1: uses backtracking
      i=2: not use backtracking

   flow chart
      (pt <proc>)    -> (env,cs):(environment, constraints)
      (redctmain cs) -> cs:(constraints)
      (redcu f cs)   -> ecs:(extended constraints), where f:{con1,con2}
      (sat<i> ecs)   -> {true,false}:bool
*)

(* variable name convention

 tg/g: time tag
 a   : attribute         
 u   : usage                      us      : list of usages
 au  : atomic usage
 t   : type                       ts      : list of types
 p   : process
 cg  : constraint on time tags
 co  : constraint on obligation   cos     : list of constraints on obligations
 ca  : constraint on attributes   cas     : constraints on attributes
 con : constraint                 cons/cs : list of constraints
 ec  : extended constraint        ecs     : list of extended constraint
 eclr/ecl/ecr : left/right-hand side of a extended constraint
 e   : a typing (a pair of a type var. and a type) 
 es  : a list of typings
 *)
 
print ("##############################################################################\n"^
       "  impdlfree.sml ver 1.0 alpha by Shin Saito (shin@is.s.u-tokyo.ac.jp)\n"^
       "  Type checker of the Implicitly-Typed Deadlock-Free Process Calculus\n"^
       "##############################################################################\n");
