fun fst (a,_) = a
fun snd (_,b) = b
fun sng x = [x]
fun id x = x
fun println str = print (str ^ "\n")
val len = length
 
fun secl x f y = f(x,y)
fun secr f y x = f(x,y)

(* repeats 'x' n times *)
fun times 0 _ = []
  | times n x = x::(times (n-1) x)

local
    fun merge _ xs [] = xs
      | merge _ [] ys = ys
      | merge f (x::xs) (y::ys) = if f x y then x::(merge f xs (y::ys))
				  else y::(merge f (x::xs) ys)
in				      
    fun sort _ [] = []
      | sort _ [x] = [x]
      | sort f xs =
	let val i = (len xs) div 2 in
	    merge f (sort f (List.take (xs,i)))
	    (sort f (List.drop (xs,i)))
	end
end

(* member e <list> *)
fun member e [] = false
  | member e (f::fs) = (e=f) orelse (member e fs)

(* uniq *)
fun uniq [] = []
  | uniq (x::xs) = if member x xs then uniq xs else x::(uniq xs)

(* (incl xs ys) returns true if (xs \supseteq ys) holds *)
fun incl xs [] = true
  | incl xs (y::ys) = (member y xs) andalso (incl xs ys)

(* list version of member: each element is a list *)
fun lmember e [] = false
  | lmember e (l::ls) = ((incl l e) andalso (incl e l)) orelse (lmember e ls)

(* used in pt.sml *)
fun fold _ [] = raise Empty
  | fold f [x] = x
  | fold f (x::xs) = f x (fold f xs)
    
(* powerset function in increasing order w.r.t. length *)
local
    fun pwsub [] = [[]]
  | pwsub (x::xs) = List.concat (map (fn ys => [ys,x::ys]) (pwsub xs))
    fun sf x y = (len x) < (len y)
in
    fun powerset xs = tl (sort sf (pwsub xs))
end

(* create a fresh tag/variable *)
local
    val id = ref 0
    val tag = ref 0
in
    fun new n =
	(id := !id + 1;
	 n^(Int.toString (!id)))
    fun newtag () =
	(tag := !tag + 1;
	 !tag)
    fun reset () = (id := 0; tag := 0)
    fun back () = id := !id -1
    fun backtag () = tag := !tag - 1
end

(* 'lremove X [v1,v2,...,vn]' returns X\{v1,v2,...,vn} where 
        each vi is a set (expressed as a list) *)
fun lremove [] vs = []
  | lremove (e::es) vs =
    if lmember e vs then lremove es vs
    else (e::(lremove es vs))

fun remove [] vs = []
  | remove (e::es) vs =
    if member e vs then remove es vs
    else (e::(remove es vs))
