(* sample process *)
val p1 = "x![].0"
val p2 = "x?[]."^p1
val p3 = "(new x)"^p2

val q1 = "x![y].0"
val q2 = "z?[w].0"
val q3 = "x?^c[z]."^q2
val q4 = q1^"|"^q3
val q5 = "(new x)(new y)("^q4^")"

val r1 = "x!^c[x].0"
val r2 = "y![x]." ^ r1
val r3 = "z?[x].z?[y].(" ^ r1 ^ "|" ^ r2 ^ ")"

val s1 = "x?[y,z].x![y].0"

val t1 = "(new x)*(x?^c[y,z].y!^o[].if b then w![].0 else 0 |" ^
                  "x?^co[y,z].z![].0)"

val t2 = "(new x)*(x!^c[].0 | x?^o[].0)"

val ex1 = "*f?[n,r].if n then r![true] else" ^ 
    "(new c)(f![n,c]|f![n,c]|c?^c[x].c?^c[y].r![x])"
val ex1a = "*f?[n,r].r![n]"
val ex1b = "*f?[n,r].(new c)(f![n,c]|f![n,c]|c?^c[x].c?^c[y].r![x])"
val ex2 = "(new y)f![true,y].y?^c[z].0"
val ex3 = "(new f)(" ^ ex1 ^ "|" ^ ex2 ^ ")"
val ex3a = "(new f)(" ^ ex1a ^ "|" ^ ex2 ^ ")"
val ex3b = "(new f)(" ^ ex1b ^ "|" ^ ex2 ^ ")"

(* sample constraint 'cs1 *)

val cs1 = [
(* 0-9 *)
	   CT(CTsim(Tvar"t2",Tvar"t1")),
	   CT(CTsim(Tchan([Tvar"t2"],2,Uin(Avar"a2",Uzero)), Tvar"t3")),
	   CT(CTsim(Tchan([Tvar"t1"],1,Uout(Avar"a1",Uzero)),
		    Tchan([Tvar"t5"],4,Uout(Avar"a4",Uzero)))),
	   CT(CTsim(Tvar"t4",Tvar"t5")), CT(CTsim(Tvar"t4",Tbool)),
	   CT(CTsim(Tvar"t5",Tbool)),
	   CT(CTsim(Tchan([Tvar"t6",Tvar"t7"],5,Uvar"u1"),
		    Tchan([Tvar"t3",Tvar"t4"],3,Uglb(Uout(Avar"a3",Uzero),Uzero)))),
 	   CT(CTsim(Tvar"t6",Tglb(Tchan([Tvar"t1"],1,Uout(Avar"a1",Uzero)),
				  Tchan([Tvar"t5"],4,Uout(Avar"a4",Uzero))))),
	   CT(CTsim(Tvar"t7",Tadd(Tglb(Tvar"t4",Tvar"t5"),Tbool))),
	   CT(CTsim(Tvar"t9",Tvar"t8")),
(* 10-19 *)
	   CT(CTsim(Tchan([Tvar"t9"],7,Uin(Avar"a7",Uzero)), Tvar"t10")),
	   CT(CTsim(Tchan([Tvar"t6",Tvar"t7"],5,Urep(Uin(Avar"a5",Uglb(Uout(Avar"a3",Uzero),Uzero)))), 
		    Tchan([Tvar"t10",Tvar"t11"],8,Uout(Avar"a8",Uzero)))),
	   CT(CTleq(Tvar"t2",Tvar"t1")), CT(CTleq(Tvar"t9",Tvar"t8")),
 	   CT(CTleq(Tvar"t6",Tglb(Tchan([Tvar"t1"],1,Uout(Avar"a1",Uzero)),
				  Tchan([Tvar"t5"],4,Uout(Avar"a4",Uzero))))),
	   CT(CTleq(Tvar"t7",Tadd(Tglb(Tvar"t4",Tvar"t5"),Tbool))),
	   CT(CTrel(Tadd(Tchan([Tvar"t2"],2,Uin(Avar"a2",Uzero)), Tvar"t3"))),
	   CT(CTrel(Tadd(Tchan([Tvar"t9"],7,Uin(Avar"a7",Uzero)), Tvar"t10"))),
	   CT(CTrel(Tadd(Tchan([Tvar"t6",Tvar"t7"],5,Urep(Uin(Avar"a5",Uglb(Uout(Avar"a3",Uzero),Uzero)))), 
			 Tchan([Tvar"t10",Tvar"t11"],8,Uout(Avar"a8",Uzero))))),
	   CT(CTtime(1,Tvar"t1")),
(* 20-29 *)
	   CT(CTtime(2,Tchan([Tvar"t1"],1,Uout(Avar"a1",Uzero)))),
	   CT(CTtime(3,Tvar"t3")), CT(CTtime(3,Tvar"t4")), CT(CTtime(4,Tvar"t5")),
	   CT(CTtime(6,Tvar"t8")), CT(CTtime(7,Tchan([Tvar"t8"],6,Uout(Avar"a6",Uzero)))),
	   CT(CTtime(8,Tvar"t10")), CT(CTtime(8,Tvar"t11")),
	   CT(CTobcap([COt(Tvar"t1")],CAinc(Ac,Avar"a1"))),
	   CT(CTobcap([COt(Tchan([Tvar"t1"],1,Uout(Avar"a1",Uzero)))],CAinc(Ac,Avar"a2"))),
(* 30-39 *)
	   CT(CTobcap([COt(Tvar"t3"),COt(Tvar"t4")],CAinc(Ac,Avar"a3"))),
	   CT(CTobcap([COt(Tvar"t5")],CAinc(Ac,Avar"a4"))),
	   CT(CTobcap([COt(Tvar"t8")],CAinc(Ac,Avar"a6"))),
	   CT(CTobcap([COt(Tchan([Tvar"t8"],6,Uout(Avar"a6",Uzero)))],CAinc(Ac,Avar"a7"))),
	   CT(CTobcap([COt(Tvar"t10"),COt(Tvar"t11")],CAinc(Ac,Avar"a8"))),
	   CA(CAinc(Az,Avar"a1")), CA(CAinc(Ac,Avar"a2")), CA(CAinc(Az,Avar"a3")),
	   CA(CAinc(Az,Avar"a4")), CA(CAinc(Az,Avar"a5")),
(* 40-42 *)
	   CA(CAinc(Az,Avar"a6")), CA(CAinc(Ac,Avar"a7")), CA(CAinc(Az,Avar"a8"))
];

val ecs1 = [EC(ECtrue,ECAt(1,2)),
	    EC(ECtrue,ECor [ECand [ECAob "a"],ECand [ECAob "b"]]),
	    EC(ECAob "a",ECfalse),
	    EC(ECtrue,ECAt(2,3))]

val ecs2 = [EC(ECtrue,ECAt(1,2)),
	    EC(ECtrue,ECor [ECand [ECAob "a"],ECand [ECAob "b"]]),
	    EC(ECAob "a",ECAt(2,1)),
	    EC(ECtrue,ECAt(2,3))]

val ecs3 = [EC(ECtrue,ECfalse),
	     EC(ECtrue,ECAt(2,3))]

val ecs4 = [EC(ECfalse,ECAt(1,2)),
	    EC(ECfalse,ECor [ECand [ECAob "a"],ECand [ECAob "b"]])]

(* used for simplex.sml *)
(* original: solvable *)
val mat1 = [[ 18, 2, 5,~3],
	    [ 10,~1,~2, 7],
	    [  3, 1, 1,~1]]

(* unsolvable *)
val mat2 = [[ 17, 2, 5,~3],
	    [ 10,~2,~2, 7],
	    [  4, 4, 1,~1]]

(* check for the smallest subscript rule *)
val eqn  = ([3,1,2],
	    [[5,~2,~3,~4, 3, 0],
	     [2, 2, 0, 0 ,1, 2],
	     [3, 3, 1, 0, 0, 6],
	     [4, 4, 0, 1, 0,12]])
 